Package picard.illumina

## Class BarcodeMetric

- java.lang.Object
- - htsjdk.samtools.metrics.MetricBase
  - - picard.illumina.BarcodeMetric

-     public class BarcodeMetric
      extends htsjdk.samtools.metrics.MetricBase

  Metrics produced by the ExtractIlluminaBarcodes program that is used to parse data in the basecalls directory and determine to which barcode each read should be assigned.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `String` | `BARCODE` | The barcode (from the set of expected barcodes) for which the following metrics apply.
    `String` | `BARCODE_NAME` | The barcode name.
    `String` | `BARCODE_WITHOUT_DELIMITER` |
    `protected byte[][]` | `barcodeBytes` |
    `String` | `LIBRARY_NAME` | The name of the library
    `long` | `ONE_MISMATCH_MATCHES` | The number of all reads matching this barcode that matched with 1 error or no-call.
    `double` | `PCT_MATCHES` | The fraction of all reads in the lane that matched to this barcode.
    `long` | `PERFECT_MATCHES` | The number of all reads matching this barcode that matched with 0 errors or no-calls.
    `double` | `PF_NORMALIZED_MATCHES` | The "normalized" matches to each barcode.
    `long` | `PF_ONE_MISMATCH_MATCHES` | The number of PF reads matching this barcode that matched with 1 error or no-call.
    `double` | `PF_PCT_MATCHES` | The fraction of PF reads in the lane that matched to this barcode.
    `long` | `PF_PERFECT_MATCHES` | The number of PF reads matching this barcode that matched with 0 errors or no-calls.
    `double` | `PF_RATIO_THIS_BARCODE_TO_BEST_BARCODE_PCT` | The rate of PF reads matching this barcode to PF reads matching the most prevalent barcode.
    `long` | `PF_READS` | The number of PF reads matching this barcode (always less than or equal to READS).
    `double` | `RATIO_THIS_BARCODE_TO_BEST_BARCODE_PCT` | The rate of all reads matching this barcode to all reads matching the most prevalent barcode.
    `long` | `READS` | The total number of reads matching the barcode.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BarcodeMetric()` | This ctor is necessary for when reading metrics from file
    `BarcodeMetric​(String barcodeName, String libraryName, String barcodeDisplay, String[] barcodeSeqs)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `BarcodeMetric` | `copy()` | Creates a copy of metric initialized with only non-accumulated and non-calculated values set
    `void` | `merge​(BarcodeMetric metric)` | Adds the non-calculated

    - ### Methods inherited from class htsjdk.samtools.metrics.MetricBase

      `equals, hashCode, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### BARCODE

          public String BARCODE

      The barcode (from the set of expected barcodes) for which the following metrics apply. Note that the "symbolic" barcode of NNNNNN is used to report metrics for all reads that do not match a barcode.

    - #### BARCODE_WITHOUT_DELIMITER

          public String BARCODE_WITHOUT_DELIMITER

    - #### BARCODE_NAME

          public String BARCODE_NAME

      The barcode name.

    - #### LIBRARY_NAME

          public String LIBRARY_NAME

      The name of the library

    - #### READS

          public long READS

      The total number of reads matching the barcode.

    - #### PF_READS

          public long PF_READS

      The number of PF reads matching this barcode (always less than or equal to READS).

    - #### PERFECT_MATCHES

          public long PERFECT_MATCHES

      The number of all reads matching this barcode that matched with 0 errors or no-calls.

    - #### PF_PERFECT_MATCHES

          public long PF_PERFECT_MATCHES

      The number of PF reads matching this barcode that matched with 0 errors or no-calls.

    - #### ONE_MISMATCH_MATCHES

          public long ONE_MISMATCH_MATCHES

      The number of all reads matching this barcode that matched with 1 error or no-call.

    - #### PF_ONE_MISMATCH_MATCHES

          public long PF_ONE_MISMATCH_MATCHES

      The number of PF reads matching this barcode that matched with 1 error or no-call.

    - #### PCT_MATCHES

          public double PCT_MATCHES

      The fraction of all reads in the lane that matched to this barcode.

    - #### RATIO_THIS_BARCODE_TO_BEST_BARCODE_PCT

          public double RATIO_THIS_BARCODE_TO_BEST_BARCODE_PCT

      The rate of all reads matching this barcode to all reads matching the most prevalent barcode. For the most prevalent barcode this will be 1, for all others it will be less than 1 (except for the possible exception of when there are more orphan reads than for any other barcode, in which case the value may be arbitrarily large). One over the lowest number in this column gives you the fold-difference in representation between barcodes.

    - #### PF_PCT_MATCHES

          public double PF_PCT_MATCHES

      The fraction of PF reads in the lane that matched to this barcode.

    - #### PF_RATIO_THIS_BARCODE_TO_BEST_BARCODE_PCT

          public double PF_RATIO_THIS_BARCODE_TO_BEST_BARCODE_PCT

      The rate of PF reads matching this barcode to PF reads matching the most prevalent barcode. For the most prevalent barcode this will be 1, for all others it will be less than 1 (except for the possible exception of when there are more orphan reads than for any other barcode, in which case the value may be arbitrarily large). One over the lowest number in this column gives you the fold-difference in representation of PF reads between barcodes.

    - #### PF_NORMALIZED_MATCHES

          public double PF_NORMALIZED_MATCHES

      The "normalized" matches to each barcode. This is calculated as the number of pf reads matching this barcode over the sum of all pf reads matching any barcode (excluding orphans). If all barcodes are represented equally this will be 1.

    - #### barcodeBytes

          protected byte[][] barcodeBytes

  - ### Constructor Detail

    - #### BarcodeMetric

          public BarcodeMetric​(String barcodeName,
                               String libraryName,
                               String barcodeDisplay,
                               String[] barcodeSeqs)

    - #### BarcodeMetric

          public BarcodeMetric()

      This ctor is necessary for when reading metrics from file

  - ### Method Detail

    - #### copy

          public BarcodeMetric copy()

      Creates a copy of metric initialized with only non-accumulated and non-calculated values set

    - #### merge

          public void merge​(BarcodeMetric metric)

      Adds the non-calculated